program rippel;

uses japi, japiKern, Modul;

CONST
  m = 10000;

var obj, datei, neu : int;
  schichthoehe : ARRAY[0..m] OF INTEGER;
  i, j, k, anfhoehe, max, q : longint;
  b, Windstaerke : REAL;
  bStr, WindstaerkeStr, qStr, maxStr, anfhoeheStr : STRING;
  first :integer;


PROCEDURE init;
  BEGIN
    FOR i:=0 TO m   DO schichthoehe[i]:=0;
    FOR i:=0 TO max DO schichthoehe[i]:=anfhoehe;
  END; {init}

FUNCTION sprungweiteL(i : INTEGER) : INTEGER;
  BEGIN
    sprungweiteL:=ROUND(Windstaerke + (b * schichthoehe[i]));
  END; {SprungweiteL}

PROCEDURE gleiten;
  VAR dh, i :INTEGER;
BEGIN
    IF (schichthoehe[max]>schichthoehe[0]) THEN BEGIN
      DEC(schichthoehe[max]);
      INC(schichthoehe[0]);
    END;
    IF (schichthoehe[max]<schichthoehe[0]) THEN BEGIN
      DEC(schichthoehe[0]);
      INC(schichthoehe[max]);
    END;

  (*IF (random<0.5) THEN BEGIN*)
    FOR i:=1 TO max-1 DO
      IF ((schichthoehe[i]>0)AND(RANDOM<0.5)) THEN
        IF schichthoehe[i]>schichthoehe[i+1] THEN BEGIN
          dh := 1+ROUND((schichthoehe[i]-schichthoehe[i+1])/3);
          IF dh<schichthoehe[i] then begin
            DEC(schichthoehe[i], dh);
            INC(schichthoehe[i+1], dh);
          END;
        END;
(*   END ELSE BEGIN*)
     FOR i:=max-1 DOWNTO 1 DO
     IF ((schichthoehe[i]>0)AND(RANDOM<0.5)) THEN
       IF schichthoehe[i]>schichthoehe[i-1] THEN BEGIN
         dh := 1+ROUND((schichthoehe[i]-schichthoehe[i-1])/3);
         IF dh<schichthoehe[i] then begin
           DEC(schichthoehe[i], dh);
           INC(schichthoehe[i-1], dh);
         END;
       END;
    (*END;*)
END; {gleiten}

PROCEDURE rahmen;
BEGIN
  loeschebildschirm(schwarz);
  zeichnelinie(xplot(-1),yplot(-1),xplot(max+1),yplot(-1),12);
  zeichnelinie(xplot(-1),yplot(-1),xplot(-1),yplot(max+1),12);
  zeichnelinie(xplot(max+1),yplot(-1),xplot(max+1),yplot(max+1),12);
END;

PROCEDURE zeigen;
BEGIN
  loeschebildschirm(schwarz);
  i:=0;
  REPEAT
{    setzepunkt(xplot(i),yplot(schichthoehe[i]),12);}
    zeichnelinie(xplot(i),yplot(schichthoehe[i]),xplot(i+1),yplot(schichthoehe[i+1]),12);
    INC(i,1);
  UNTIL i>= max
END;

PROCEDURE sandhaufen;
VAR x, j : INTEGER;
    richtung : REAL;
BEGIN
  j:=1;
  REPEAT
    INC(j);
    i:=ROUND(random*max);
    IF schichthoehe[i]>q then begin
      x:=SprungweiteL(i);
      IF (i+x<=max) THEN BEGIN
        schichthoehe[i] := schichthoehe[i] - q;
        schichthoehe[i+x] := schichthoehe[i+x] + q;
      END ELSE BEGIN
        schichthoehe[i] := schichthoehe[i] - q;
        schichthoehe[(i+x)-max] := schichthoehe[(i+x)-max] + q;
      END;
    END;
  UNTIL j>=max;
END; {sandhaufen}


PROCEDURE gleiten2;
VAR x, j, dh, i : INTEGER;
    richtung : REAL;
BEGIN
    IF (schichthoehe[max]>schichthoehe[0]) THEN BEGIN
      DEC(schichthoehe[max]);
      INC(schichthoehe[0]);
    END;
    IF (schichthoehe[max]<schichthoehe[0]) THEN BEGIN
      DEC(schichthoehe[0]);
      INC(schichthoehe[max]);
    END;

  j:=1;
  REPEAT
    INC(j);
    i:=1+ROUND(random*(max-1));
    IF schichthoehe[i]>schichthoehe[i+1] THEN BEGIN
      dh := 1+ROUND((schichthoehe[i]-schichthoehe[i+1])/3);
      IF dh<schichthoehe[i] then begin
        DEC(schichthoehe[i], dh);
        INC(schichthoehe[i+1], dh);
      END;
    END;
    IF schichthoehe[i]>schichthoehe[i-1] THEN BEGIN
      dh := 1+ROUND((schichthoehe[i]-schichthoehe[i-1])/3);
      IF dh<schichthoehe[i] then begin
        DEC(schichthoehe[i], dh);
        INC(schichthoehe[i-1], dh);
      END;
    END;
  UNTIL j>=max;
END; {sandhaufen}




begin {Hauptprogramm}

  first:=1;

  randomize;

 while ((obj<>frame) and (obj<>quit)) do begin

 obj := action;

  if (obj=input) then begin
    first:=0;
    max := 1000;
    WandleZahlInString(max,4.0,maxStr);
    anfhoehe:=50;
    WandleZahlInString(anfhoehe,3.0,anfhoeheStr);
    b:=2.0;
    WandleZahlInString(b,3.2,bStr);
    Windstaerke:=5.0;
    WandleZahlInString(Windstaerke,3.2,WindstaerkeStr);
    q:=1;
    WandleZahlInString(q,3,qStr);
    repeat
      liesinteger(' Programm zur Simulation von Sandrippeln nach Nishimori - Schichtbreite : ', maxStr, max);
    until (max<m+1);
    liesinteger(' Schichtdicke (<Schichtbreite) : ', anfhoeheStr, anfhoehe);
    liesreal(' Faktor "b" : ',bStr, b);
    liesreal(' Windstaerke (0..?) : ',WindstaerkeStr, Windstaerke);
    liesinteger(' Faktor "q" : ', qStr, q);

  {   setzegrafikmodus;}
     setzeBildschirmausschnitt(50,xm-50,50,ym-150);
     dimensioniereBildschirm(0,max,0,max);
     init;
     zeigen;
  end;

  if (obj=start) then begin
    do_work:=true;
  end;

  {  setbkcolor(schwarz);}
{  if (obj=input) then begin
    liesreal(' Faktor "b" : ',bStr, b);
    liesreal(' Windstaerke (0..?) : ',WindstaerkeStr, Windstaerke);
    liesinteger(' Faktor "q" : ', qStr, q);
    obj:=start;
   END;}


  if (do_work) then begin
  { REPEAT  }
      FOR k:=1 TO 3 DO sandhaufen;
      FOR k:=1 TO 20 DO gleiten2;
      zeigen;
  {UNTIL anhalten;  }
  end;

  if (obj=stop) then begin
    do_work:=false;
  end;


 end;
 programmende;

end.


